-- Departments amb pitjor ratio d'incidents en el darrer any
SELECT name FROM department 
WHERE id_department=(SELECT worst_ratio_department FROM general_stats WHERE id=1);

-- Numero de dispositius comprats per la empresa en un any determinat (ex 2022)
SELECT devices_bought FROM year_stats WHERE year=2022;

-- Percentatge de laptops sense incidents des de la darrera assignacio respecte al total
SELECT (laptops_no_trouble) :: double precision / (laptops) :: double precision * 100 pct_laptops_no_trouble
FROM general_stats WHERE id=1;

-- Import de les comandes asociades a una ordre d'inversio (ex 33) en un any determinat (ex 2022)
SELECT ammount FROM investment_order_year WHERE id_investment_order = 33 AND year = 2022;

-- Proveïdor amb el temps d'entrega més curt
SELECT name as fastest_supplier FROM supplier 
WHERE id_supplier=(SELECT fastest_supplier FROM general_stats WHERE id=1);

-- Per un departament (ex 5) quantitat de dispositius de cada tipus
SELECT device_type.description, devices_per_type.units from devices_per_type 
INNER JOIN device_type
ON devices_per_type.id_device_type = device_type.id_device_type
WHERE devices_per_type.id_department = 5;

-- Valor del inventary actiu de cada departament
SELECT name,inventory from department;

-- numero de dispositius amb data d'inventari major que un any 
SELECT old_inventory_devices FROM general_stats;

-- usuari amb mes incidencies aquest any
SELECT first_name, last_name FROM usuari 
WHERE id_user = (SELECT trouble_maker FROM general_stats WHERE id=1);

-- departament que, en un any concret (ex 2022), ha fet més reassignacions
SELECT name FROM Department
WHERE id_department = (SELECT id_department FROM year_stats WHERE year = 2022);

-- Percentatge d'usuaris sense dispositius
SELECT (users_no_device) :: double precision / (users) :: double precision * 100 as pct_users_with_no_device
FROM general_stats WHERE id=1;

-- Per una auditoria de processos (ex 2), registres auditats  
SELECT * FROM process_check WHERE id_process_audit = 2;
-- i total
SELECT total_checks FROM process_audit WHERE id_process_audit =2;

-- Per una auditoria financera (ex 2), registres auditats  
SELECT * FROM inventory_check WHERE id_financial_audit = 2;
-- i total
SELECT total_checks FROM financial_audit WHERE id_financial_audit =2;

-- Departament amb més tipus de dispusitius i numero
SELECT department.name, general_stats.device_type_number FROM department
INNER JOIN general_stats
ON department.id_department = general_stats.most_device_types_dept 
WHERE general_stats.id = 1;

-- Numero d'usuaris amb mes de 5 dispositius assignats
SELECT users_over5_devices FROM general_stats;

-- Top 10 usuaris per numero d'incidencies
SELECT first_name, last_name , total_incidents FROM usuari 
ORDER by total_incidents DESC
LIMIT 10;

-- Dispositius assignats a un usuari (ex 3)
SELECT device.id_device, id_device_type, last_inventory_check from device JOIN current_assigment
ON device.id_device = current_assigment.id_device
WHERE current_assigment.id_user = 3;

-- Pressupost aprovat i executat de cada departament per un any determinat (ex 2021)
SELECT department.name, budget.aproved, budget.executed FROM departament
INNER JOIN budget
ON department.id_department = budget.id_department
WHERE budget.year = 2021;


-- Consulta de errors al LOG
select * from log where rsp!='OK' order by id desc limit 5;