######
#
#  Càrrega massiva de dades pel TFG d'Enric Garcia
#
#####


import psycopg2
from datetime import datetime, timedelta
from random import randint,randrange,choice
import time

# Constants
BBDD = 'postgres'
HOST = 'localhost'
USER = 'postgres'
PASW = 'postgres'
PORT = '5432'

INICI = datetime(2022,1,15, 0,0,0)
CICLES = 250000
MIN_S = 30        # mínim numero de segons que el temps avança per iteració
MAX_S = 600      # màxim numero de segons que el temps avança per iteració

print('Conectant amb la BBDD i inicialitzant dades')
# connexió amb la bbdd
conn = psycopg2.connect("dbname= 'postgres' user='postgres' host='localhost' password='uoc' port='5433'")
curs = conn.cursor()

# dades de suport
taules = ['action','general_stats',"year_stats","process_check","process_audit","incident","current_assigment","usuari","devices_per_type","budget","department","inventory_check",
          "financial_audit","order_line","device","investment_order_year","orderx","investment_order","action_type","status","device_type","supplier","log"]

sequencies = ["action_type_id_action_type_seq","status_id_status_seq","device_type_id_device_type_seq","supplier_id_supplier_seq","department_id_department_seq","device_id_device_seq",
              "financial_audit_id_financial_audit_seq","incident_id_incident_seq","investment_order_id_investment_order_seq","orderx_id_order_seq","process_audit_id_process_audit_seq",
              "usuari_id_user_seq","log_id_seq"]

tecnics=[]
suppliers=[]
comandes_inversio=[]
comandes_pendents=[]
dispositius_pendents_alta=[]
dispositius_disponibles=[]
dispositius_assignats=[]
assignacions=[]
incidents=[]

# Inicialització BBDD
for taula in taules:
    sql = "DELETE FROM " + taula
    curs.execute(sql)
    conn.commit()

for seq in sequencies:
    sql = "ALTER SEQUENCE "+seq+" RESTART WITH 1"
    curs.execute(sql)
    conn.commit()

curs.execute ('INSERT INTO general_stats(id) VALUES (1)')

# Dades bàsiques
action_types = ['alta','assignació','alliberament','baixa']
status = ['pendent','no assignat','assignat','baixa']
device_types = ['laptop','desktop','monitor','inkjet printer','laser printer','tablet','mouse','keyboard','speaker','webcam','usb disk','scanner','plotter','router','switch','server']
departments = ['IT','Accounting','Production','Marketing','Sales','Quality','Financial','Purchasing','Research']

sql = sql = "INSERT INTO action_type(description) VALUES (%s)"
for type in action_types:
    dades =(type,)
    curs.execute(sql,dades)
    conn.commit()

sql = sql = "INSERT INTO status(description) VALUES (%s)"
for type in status:
    dades =(type,)
    curs.execute(sql,dades)
    conn.commit()

sql = sql = "INSERT INTO device_type(description) VALUES (%s)"
for type in device_types:
    dades =(type,)
    curs.execute(sql,dades)
    conn.commit()

sql = sql = "INSERT INTO department(name) VALUES (%s)"
for nom in departments:
    dades =(nom,)
    curs.execute(sql,dades)
    conn.commit()

curs.execute('UPDATE general_stats SET laptop=1, it_department=1 WHERE id=1')

# Proveïdors
with open('suppliers.txt',encoding="utf8") as f:
    line = f.readline()
    while line:
        suppliers.append(line[:-1])
        line = f.readline()
f.close()

sql = "INSERT INTO supplier(name) VALUES (%s)"

for supplier in suppliers:
    dades = (supplier,)
    curs.execute(sql,dades)
    conn.commit()

# Usuaris
homes=[]
with open('men.txt',encoding="utf8") as f:
    line = f.readline()
    while line:
        homes.append(line[:-1])
        line = f.readline()
f.close()

dones=[]
with open('women.txt',encoding="utf8") as f:
    line = f.readline()
    while line:
        dones.append(line[:-1])
        line = f.readline()
f.close()

cognoms=[]
with open('last_name.txt',encoding="utf8") as f:
    line = f.readline()
    while line:
        cognoms.append(line[:-1])
        line = f.readline()
f.close()

sql = "SELECT id_department FROM department"
curs.execute(sql)
departaments = curs.fetchall()
departaments = [x[0] for x in departaments]

sql = "INSERT INTO usuari(first_name, last_name, id_department) VALUES (%s,%s,%s)"
for i in range(1,10001):
    dona = choice([True,False])
    if dona:
        nom = choice(dones)
    else:
        nom = choice(homes)
    cognom = choice(cognoms)
    dept = choice(departaments)
    dades =(nom,cognom,dept,)
    curs.execute(sql,dades)
    conn.commit()
    # si es un tecnic el guardo
    if dept == 1:
        tecnics.append(i)

# Cicles en la linia temporal

data = INICI
dia = data.day
mes = data.month
any = data.year
f_audit = 1
p_audit = 1
invest_order = 1
comanda = 1
incident =  1
dispositiu = 1
start = time.time()
interval1 = start
print ('Data inicial de les proves:', data)
print ('generant',CICLES,'cicles')
for i in range(1,CICLES+1):
    if i%(CICLES/100) == 0:
        interval2 = time.time()
        print("temps per iteracio:{:d} {:d}:{:02d} (mm:ss)".format(i,int((interval2-interval1)//60),int((interval2-interval1)%60)))
        interval1 = interval2
    t = randint(MIN_S,MAX_S)
    data = data+timedelta(seconds=t)
    # executar procés anual
    if data.year != any or i==1 :
        any = data.year
        # no puc cridar cada_any perque llegeix l'any del sistema.
        # curs.execute("CALL cada_any();")
        # fare les crides equivalents
        sql = "INSERT INTO year_stats(year) VALUES (%s)"
        dades =(any,)
        curs.execute(sql,dades)
        conn.commit()
        curs.execute("UPDATE usuari SET incidents_current_year=0")
        conn.commit()
        curs.execute("UPDATE department SET year_assigments=0")
        conn.commit()

    # executar procés mensual
    if data.month != mes:
        mes = data.month
        curs.execute("CALL cada_mes();")
    # executar procés diari
    if data.day != dia:
        dia = data.day
        # no puc cridar cada_dia perque llegeix la data del sistema
        #curs.execute("CALL cada_dia();")
        sql="UPDATE general_stats SET old_inventory_devices = (SELECT COUNT(*) from device where %s>last_inventory_check + interval '1 year')";
        dades=(data,)
        curs.execute(sql,dades)
        conn.commit()

        # Final de Trimestre
        if (data.day,data.month) in [(31,3),(30,6),(30,9),(31,12)] :

            # Inventari
            tots = dispositius_pendents_alta + dispositius_disponibles + dispositius_assignats
            percentatge = randint (5,20)                                                           # controlarem entre un 5 i un 20% dels dispositius cada cop
            controls = len(tots)*percentatge//100
            curs.execute("INSERT INTO financial_audit(company) VALUES('BDO')")
            conn.commit()

            for _ in range(controls):
                disp = choice(tots)
                tots.remove(disp)
                dades = (f_audit,disp,data,)
                curs.execute('INSERT INTO inventory_check(id_financial_audit,id_device,date) VALUES (%s,%s,%s)', dades)
                conn.commit()

            f_audit += 1

            # Llençar un numero aleatori (de 0 a 15) comandes d'inversió
            num = randint(0,15)
            sql = 'INSERT INTO investment_order(date) VALUES(%s)'
            dades =(data,)
            for _ in range(num):
                curs.execute(sql,dades)
                conn.commit()
                comandes_inversio.append((invest_order,data))
                invest_order += 1

                # elimino de les comandes disponibles les que tenen mes de 6 mesos
            for i_o in comandes_inversio:
                if i_o[1] < data:
                    comandes_inversio.remove(i_o)

        # Final de Semestre
        if (data.day,data.month) in [(30,6),(31,12)] :

            # Auditoria de Processos
            tots = incidents[:]
            percentatge = randint (5,20)                                                           # controlarem entre un 5 i un 20% dels incidents cada cop
            controls = len(tots)*percentatge//100
            curs.execute("INSERT INTO process_audit(company) VALUES('BDO')")
            conn.commit()

            for _ in range(controls):
                inci = choice(tots)
                tots.remove(inci)
                dades = (p_audit,inci,data,)
                curs.execute('INSERT INTO process_check(id_process_audit,id_incident,date) VALUES (%s,%s,%s)', dades)
                conn.commit()

            p_audit += 1

    # executar un ABM aleatori
    # 1: order 5% , 2: recepció material 25%, 3: acció, 4 60% : incident 10%
    if i < 10000 :
        percentatges = [1]*40 + [2]*30 + [3]*25 + [4]*5
    else:
        percentatges = [1]*5 + [2]*25 + [3]*60 + [4]*10
    abm = choice(percentatges)

    # Comanda
    if abm == 1:
        # comanda (inversio o no)
        inversio = choice([True,True,True,False])   # el 75% de les comandes seran d'inversio
        supplier = randint(1,100)
        if inversio and comandes_inversio:
            i_o , _ =  choice(comandes_inversio)
            sql = 'INSERT INTO orderx(id_supplier,id_investment_order,date_issued) VALUES(%s,%s,%s)'
            dades = (supplier,i_o,data,)
        else:
            sql = 'INSERT INTO orderx(id_supplier,date_issued) VALUES(%s,%s)'
            dades = (supplier,data,)

        curs.execute(sql,dades)
        conn.commit()

        # linies de comanda
        linies = randint(1,10)      # numero de linies per la comanda
        sql = 'INSERT INTO order_line(id_order,description,price,id_device_type) VALUES(%s,%s,%s,%s)'
        for lin in range(1,linies+1):
            tipus = randint(1,len(device_types))
            preu = randint(50,5000)
            descripcio = 'comanda {} línia {}'.format(comanda,i)
            dades = (comanda,descripcio,preu,tipus,)
            curs.execute(sql,dades)
            conn.commit()
            comandes_pendents.append((comanda,lin))

        comanda += 1

    # Recepció
    if abm == 2 and comandes_pendents:
        linia  = choice(comandes_pendents)
        sql = 'UPDATE order_line SET date_received = %s WHERE id_order = %s AND id_line = %s'
        dades =(data, linia[0],linia[1],)
        curs.execute(sql,dades)
        conn.commit()
        comandes_pendents.remove(linia)
        dispositius_pendents_alta.append(dispositiu)
        dispositiu += 1

        # Acció
    if abm == 3:
        # 1: alta 40% , 2: assignacio 50%, 3: alliberament 4 5% : baixa 5%
        percentatges = [1]*40 + [2]*50 + [3]*5 + [4]*5
        tipus = choice(percentatges)
        tecnic = choice(tecnics)
        sql = 'INSERT INTO action(id_device,id_user,id_action_type,date,responsable) VALUES(%s,%s,%s,%s,%s)'

        # alta
        if tipus == 1 and dispositius_pendents_alta:
            disp = choice(dispositius_pendents_alta)
            dades =(disp,tecnic,tipus,data,tecnic,)
            curs.execute(sql,dades)
            conn.commit()
            dispositius_pendents_alta.remove(disp)
            dispositius_disponibles.append(disp)

        # assignacio
        if tipus == 2 and dispositius_disponibles:
            usuari = randint(1,10000)
            disp = choice(dispositius_disponibles)
            dades =(disp,usuari,tipus,data,tecnic,)
            curs.execute(sql,dades)
            conn.commit()
            dispositius_disponibles.remove(disp)
            dispositius_assignats.append(disp)
            assignacions.append((disp,usuari))

        # alliberament
        if tipus == 3 and assignacions:
            disp,usuari = choice(assignacions)
            dades =(disp,usuari,tipus,data,tecnic,)
            curs.execute(sql,dades)
            conn.commit()
            dispositius_disponibles.append(disp)
            dispositius_assignats.remove(disp)
            assignacions.remove((disp,usuari))

        # baixa
        if tipus == 4 :
            assignat = choice([True,False])  # donar de baixa dispositiu assignat o pendent

            if assignat and assignacions:
                disp,usuari = choice(assignacions)
                dades =(disp,usuari,tipus,data,tecnic,)
                curs.execute(sql,dades)
                conn.commit()
                dispositius_assignats.remove(disp)
                assignacions.remove((disp,usuari))
            elif dispositius_disponibles :
                disp = choice(dispositius_disponibles)
                dades =(disp,tecnic,tipus,data,tecnic,)
                curs.execute(sql,dades)
                conn.commit()
                dispositius_disponibles.remove(disp)

    # Incident
    if abm == 4 and  dispositius_assignats:
        disp = choice(dispositius_assignats)
        tecnic = choice(tecnics)
        descripcio = choice(['no arrenca','fa soroll','surten coses rares','no se que pasa'])
        sql = 'INSERT INTO incident(id_device,date,description,technician) VALUES(%s,%s,%s,%s)'
        dades =(disp,data,descripcio,tecnic,)
        curs.execute(sql,dades)
        conn.commit()
        incidents.append(incident)
        incident += 1

print ('Data final de les proves:', data)
end = time.time()
print("final en {:d}:{:02d} (mm:ss)".format(int((end-start)//60),int((end-start)%60)))
